Name:           virtio-forwarder
Version:        1.5.99.13
Release:        1%{?dist}
Summary:        SR-IOV virtual function to virtio packet forwarder

License:        BSD
URL:            http://netronome.com
Source0:        https://rpm.netronome.com/archives/virtio-forwarder/virtio-forwarder-1.5.99.13-1.tar.bz2

## Common Requires
Requires:       libbsd

## Fedora Requires and BuildRequires
%if 0%{?fedora}
Requires:       python3-protobuf
Requires:       python-zmq
BuildRequires:  python-devel
BuildRequires:  python-sphinx
BuildRequires:  python-sphinx_rtd_theme
%endif

## Rhel/CentOS 7.x
%if 0%{?rhel} && 0%{?rhel} >= 7 && 0%{?rhel} < 8
Requires:       protobuf-python
Requires:       python2-zmq
BuildRequires:  python-devel
BuildRequires:  python-sphinx
BuildRequires:  python-sphinx_rtd_theme
%endif

## Rhel/CentOS 8.x
%if 0%{?rhel} && 0%{?rhel} >= 8
Requires:       python3-protobuf
Requires:       python3-zmq
BuildRequires:  python3-devel
BuildRequires:  python3-sphinx
BuildRequires:  python3-sphinx_rtd_theme
%endif

## Common Requires and BuildRequires
BuildRequires:  meson make gcc

# HK: When building statically linked packages this line will be removed by
# the Meson build system
BuildRequires:  dpdk-devel

# Note, for CentOS 8.x the 'PowerTools' repo needs to be enabled for these
BuildRequires:  protobuf-c-compiler protobuf-c-devel protobuf-compiler
BuildRequires:  zeromq-devel
BuildRequires:  numactl-devel
BuildRequires:  libbsd-devel
%{?systemd_requires}
BuildRequires:  systemd

# Track DPDK's architectures
ExclusiveArch: x86_64 aarch64 ppc64le %ix86

# This gets populated when building n statically linked virtio-forwarder package


%description
virtio-forwarder is a userspace networking application that forwards
bi-directional traffic between SR-IOV virtual functions and virtio networking
devices in QEMU virtual machines. virtio-forwarder implements a virtio backend
driver using the DPDK’s vhost-user library and services designated VFs by means
of the DPDK poll mode driver (PMD) mechanism.

%prep
%setup -q

%build
%undefine _annotated_build

# This PKG_CONFIG_PATH is only needed until the upstream dpdk-devel package in
# Fedora and CentOS starts shipping a libdpdk.pc file. Until then a custom one
# is generated and placed in /tmp/pkgconfig (by meson)
export PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/tmp/pkgconfig \
	%meson 
export PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/tmp/pkgconfig \
	%meson_build

%install
%meson_install

%post
%systemd_post virtio-forwarder.service
%systemd_post vio4wd_core_scheduler.service

%preun
%systemd_preun virtio-forwarder.service
%systemd_preun vio4wd_core_scheduler.service

%postun
%systemd_postun virtio-forwarder.service
%systemd_postun_with_restart vio4wd_core_scheduler.service

%files
%{_bindir}/virtio-forwarder
%{_mandir}/man8/virtio-forwarder.8.*
%{_libdir}/virtio-forwarder
%config(noreplace) %{_sysconfdir}/default/virtioforwarder
%{_unitdir}/virtio-forwarder.service
%{_unitdir}/vio4wd_core_scheduler.service
%doc README.md
%license LICENSE

%changelog
* Fri Mar 17 2023 Heinrich Kuhn <heinrich.kuhn@netronome.com> - 1.5.99.13-1
- Initial release
